# Команды 
Сервер имеет различные команды для работы с аккаунтами, врагами и загрузкой сцен. Все команды, их аргументы и примеры использования представлены ниже:

Прим.: <> - обязательные аргументы; [] - необязательные;
|Команда        |Назначение                      |Аргументы                     |Необходим target? |Полная команда                    |Пример использования    |
|:--------------|:-------------------------------|:-----------------------------|:-----------------|:---------------------------------|:-----------------------|
|help           |Показывает все доступные команды|Отсутствуют                   |Нет               |help                              |help                    |
|target         |Выбирает активного пользователя |\<uid>                        |Нет               |target \<uid>                     |target 740623067        |
|scene          |Загружает сцену                 |\<id сцены>                   |Да                |scene \<id сцены>                 |scene 209               |
|kick           |Отключает пользователя от сессии|Отсутствуют                   |Да                |kick                              |kick                    |
|spawn          |Спавнит врагов рядом с игроком  |\<TemplateID врага> \<уровень>|Да                |spawn \<TID> \<уровень>           |spawn eny_0007_mimicw 20|
|heal           |Лечит персонажей из отряда      |Отсутствуют                   |Да                |heal                              |heal                    |
|add            |Добавляет предметы, оружие, персонажей|\<item\|weapon\|char> \<id> \<кол-во/уровень>|Да                |add \<item\|weapon\|char> \<id> \<кол-во/уровень>|add char chr_0007_ikut 80|
|remove         |Удаляет персонажа               |\<id>                         |Да                |remove \<id>                      |remove chr_0007_ikut    |
|level          |Устанавливает предмету или персонажу уровень|[id персонажа\|оружия] \<уровень>|Да                |level [id персонажа\|оружия] \<уровень>|level wpn_funnel_0010 80|
|charinfo       |Выдаёт информацию о персонаже   |\<id>                         |Да                |charinfo \<id>                    |charinfo chr_0007_ikut  |
|nickname       |Изменяет никнейм в игре         |\<никнейм>                    |Да                |nickname \<никнейм>               |nickname blob           |
|account        |Создаёт аккаунт в базе данных   |\<create\|reset> \<никнейм>   |Нет               |account <create\|reset> \<никнейм>|account create test     |
|players        |Показывает список всех игроков  |Отсутствуют                   |Нет               |players                           |players                 |
|clear          |Очищает консоль                 |Отсутствуют                   |Нет               |clear                             |clear                   |
|unlockall      |Разблокирует все разрешения     |Отсутствуют                   |Да                |unlockall                         |unlockall               |
|idlist         |Показывает id                   |\<chars\|enemies\|scenes>     |Нет               |idlist \<chars\|enemies\|scenes>  |idlist chars            |

> [!WARNING]
> Команда `level`: если не прописать конкретный `id`, то уровень будет изменён *всем* оружиям и персонажам.

> [!NOTE]
> Команда `nickname`: команда поддерживает кириллицу.